<template>
  <div class="listing page" :class="{loading: isLoading == true}">
      <div class="page-wrapper">
        <div class="table-wrapper">
          <table class="table-orders" :data-role="currentRole">
            <tbody>
              <tr>
                <th v-if="currentVenue == 'shanghai'">座机</th>
                <th>轮候号码</th>
                <th>调酒</th>
                <th v-if="currentRole == 'bartender'">完成调酒</th>
                <th v-if="currentRole == 'service'">领取</th>
              </tr>
              <tr v-for="(order, index) in orders" 
                :class="{ 
                  completed: order.completed == true, 
                  icecream: order.drinkid == 'vsop_ice_cream' || order.drinkid == 'xo_ice_cream' , 
                  milkshake: order.drinkid == 'cp_milkshake'
                }"
                v-if="order.delivered != true" >
                <td class="cell-stand" v-text="order.stand" v-if="currentVenue == 'shanghai'"></td>
                <td class="cell-ordernumber" v-text="order.ordernumber"></td>
                <td class="cell-drinkName" v-text="getDrinkNameFromId(order.drinkid)"></td>
                <td class="cell-complete" v-if="currentRole == 'bartender'">
                  <a 
                  @click="completeOrder(order.ordernumber)" 
                  :data-order="order.ordernumber" class="btn-brand btn-complete" 
                  :class="{completed: order.completed == true}">
                    <span v-if="order.completed == false">完成</span>
                    <span v-if="order.completed == true">已完成</span>
                  </a>
                </td>
                <td class="cell-deliver" v-if="currentRole == 'service'">
                  <a 
                  @click="deliverOrder(order.ordernumber)" 
                  :data-order="order.ordernumber" 
                  class="btn-brand btn-deliver" 
                  :class="{completed: order.completed == false}">
                    <span v-if="order.completed == false">准备中</span>
                    <span v-if="order.completed == true">发送</span>
                  </a>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>
      <div class="controls">
        <a class="btn-refresh" @click="fetchOrders">重新整理</a>
      </div>
  </div>
</template>

<script>
import JQuery from 'jquery'
//import io from 'socket.io-client'

export default {
  name: 'Listing',
  data () {
    return {
      api: this.getApi(),
      isLoading: false,
      //socket : io(this.$config.socket_port),
      currentRole: this.getCookie("Bar_hennessy_role"),
      currentVenue: this.getCookie("Bar_hennessy_venue"),
      intervalFn: function(){},
      orders: [
        /*{
          stand         : 'A',
          ordernumber   : 1120,
          drinkid       : 'classivm_expresso',
          userId        : '',
          completed     : false,
          delivered     : false,
        },{
          stand         : 'B',
          ordernumber   : 1121,
          drinkid       : 'cp_milkshake',
          userId        : '',
          completed     : false,
          delivered     : false,
        },{
          stand         : 'A',
          ordernumber   : 1122,
          drinkid       : 'xo_ice_cream',
          userId        : '',
          completed     : true,
          delivered     : false,
        },{
          stand         : 'A',
          ordernumber   : 1123,
          drinkid       : 'classivm_expresso',
          userId        : '',
          completed     : false,
          delivered     : false,
        },{
          stand         : 'B',
          ordernumber   : 1124,
          drinkid       : 'cp_milkshake',
          userId        : '',
          completed     : true,
          delivered     : false,
        },{
          stand         : 'A',
          ordernumber   : 1125,
          drinkid       : 'xo_ice_cream',
          userId        : '',
          completed     : false,
          delivered     : false,
        }*/
      ]
    }
  },
  methods: {
    getApi: function(){
      var _venue = this.getCookie("Bar_hennessy_venue");
      if(_venue == '' || _venue == 'undefined' || _venue  == null){
        this.$router.push('/config') //success -> goto ticket 
        return false;
      }
      return this.$config.api_url[_venue].api_prefix
    },
    fetchOrders: function(){
      var vm = this;
      clearInterval(vm.intervalFn);
      if(vm.api == false){
        vm.initIntervalFn();
        return;
      }
      vm.isLoading = true;
      JQuery.post( vm.api + '/api/getOrders' )
      .done(function( response ) {
        vm.isLoading = false;
        var data = response.drinks;
        vm.orders = [].concat(data);

        vm.initIntervalFn();
      })
      .fail(function ( response ){
        vm.isLoading = false;
        vm.initIntervalFn();
      })
      /*vm.$axios
      .post(vm.api + '/api/getOrders')
      .then(function(response){
        console.log(vm.api + '/api/getOrders : response: ', response);
        var data = response.data;
        vm.orders = vm.orders.concat(data);
      })
      .catch(function(error){
        console.log(error)
      })*/
    },
    completeOrder: function(ordernumber){
      var vm = this;
      var submitData = {
        ordernumber: ordernumber
      }
      clearInterval(vm.intervalFn);
      vm.isLoading = true;
      JQuery.post( vm.api + '/api/completeOrder', submitData )
      .done(function( data ) {
        vm.isLoading = false;
        vm.fetchOrders();
        //vm.initIntervalFn();
      });
    },
    deliverOrder: function(ordernumber){
      var vm = this;
      var submitData = {
        ordernumber: ordernumber
      }
      clearInterval(vm.intervalFn);
      vm.isLoading = true;
      JQuery.post( vm.api + '/api/deliverOrder', submitData )
      .done(function( data ) {
        vm.isLoading = false;
        vm.fetchOrders();
        //vm.initIntervalFn();
      });
    },
    getDrinkNameFromId(id){
      var vm = this;
      if(vm.getCookie("Bar_hennessy_venue") != ''){
        var drinks = vm.$config.drinks[vm.getCookie("Bar_hennessy_venue")];
        var drink = drinks.filter(drink => drink.drinkId == id)[0];
        return drink.name;
      }else{
        return 'Please set the venue location in config page first';
      }
    },
    checkCookie: function(){
      var vm = this;
      var hennessy_role = vm.getCookie("Bar_hennessy_role");
      var hennessy_venue = vm.getCookie("Bar_hennessy_venue");

      if (hennessy_role == 'bartender') {
        vm.$config.role = hennessy_role;
      }else if( hennessy_role =='service' ){
        vm.$config.role = hennessy_role;
      }

      if (hennessy_venue == 'shanghai') {
        vm.$config.venue = hennessy_venue;
      }else if( hennessy_venue =='malaysia' ){
        vm.$config.venue = hennessy_venue;
      }
      
      if( hennessy_venue == '' || hennessy_role == ''){
        vm.$router.push({ 
          path: '/config' 
        })
      }
    },
    getCookie: function(cname) {
      var name = cname + "=";
      var decodedCookie = decodeURIComponent(document.cookie);
      var ca = decodedCookie.split(';');
      for(var i = 0; i <ca.length; i++) {
          var c = ca[i];
          while (c.charAt(0) == ' ') {
              c = c.substring(1);
          }
          if (c.indexOf(name) == 0) {
              return c.substring(name.length, c.length);
          }
      }
      return "";
    },
    evt: function(){
      var vm = this;
      /*JQuery("body").on('click', '.btn-complete', function(e){
        e.preventDefault();
        var ordernumber = JQuery(this).attr('data-order');
        vm.completeOrder(ordernumber);
        //console.log('clicked complete', ordernumber)
        //vm.socket.emit('order completed', ordernumber);
        return false;
      })
      JQuery("body").on('click', '.btn-deliver', function(e){
        e.preventDefault();
        var ordernumber = JQuery(this).attr('data-order');
        vm.deliverOrder(ordernumber);
        //console.log('clicked deliver', ordernumber)
        //vm.socket.emit('order delivered', ordernumber);
        return false;
      })*/
    },
    unbindEvt: function(){
      var vm = this;
      //JQuery("body").off('click', '.btn-complete');
      //JQuery("body").off('click', '.btn-deliver');
      //clearInterval(vm.intervalFn);
    },
    initIntervalFn: function(){
      var vm = this;
      vm.intervalFn = setInterval(function(){
        vm.fetchOrders();
      },5000)
    }
  },
  mounted: function(){
    this.checkCookie();
    this.evt();
    this.fetchOrders();
    /*this.socket.on('order completed', function(ordernumber){
      console.log('socket: order completed', ordernumber);
    });
    this.socket.on('order delivered', function(ordernumber){
      console.log('socket: order delivered', ordernumber);
    });*/
  },
  beforeDestroy() {
    //this.unbindEvt();
  },
  
}
</script>

<style lang="sass">
@import "../../styles/Listing.sass"
</style>
